/* tmnr2r.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

int main(void)
{
    /* Initialized data */
    static float a[2] = { -1.3f,.5f };
    static float b[2] = { .5f,1.f };
    static float ge[2] = { 1e-9f,1e-9f };
    static float xe[2] = { 1e-9f,1e-9f };
    static int i0[2] = { 1,1 };
    static float fe = 1e-19f;
    static float rm[33] = { 100.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,
            0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,
            0.f,0.f,0.f,0.f,0.f };

    /* Local variables */
    extern int grad_c(), func_c();
    extern int mnr2r_c(float *, float *, int *, float *, float *, int *,
                       U_fp, float *, float *, U_fp, float *, float *,
                       float *, float *, int *, int *);
    static float f, g[2];
    static int n, w;
    static float x[2], up[4];
    static int irm[2];

    n = 2;
    up[0] = 1e-10f;
    up[1] = 1e-10f;
    up[2] = .1f;
    up[3] = 2.f;
    x[0] = -1.2f;
    x[1] = 1.f;
    printf("\n %5i \n", w);
    printf("\n %6.1f %6.1f \n", a[0], a[1]);
    printf("\n %6.1f %6.1f \n", b[0], b[1]);
    printf("\n %12.5e %12.5e \n", x[0], x[1]);
    mnr2r_c(x, xe, i0, a, b, &n, (U_fp)func_c, &f, &fe, (U_fp)grad_c, g, ge,
            up, rm, irm, &w);

    printf("\n %5i \n", w);
    printf("\n %9.1f %9.1f %9.1f \n", rm[0], rm[1], rm[2]);
    printf("\n %14.4e \n", f);
    printf("\n %14.5e %14.5e \n", x[0], x[1]);
    printf("\n %14.5e %14.5e \n", g[0], g[1]);
    return 0;
} /* main */

int func_c(float *x, float *f, float *fe)
{
    /* System generated locals */
    float r__1, r__2, r__3;

    /* Parameter adjustments */
    --x;

    /* Function Body */
/* Computing 2nd power */
    r__2 = x[1];
/* Computing 2nd power */
    r__1 = x[2] - r__2 * r__2;
/* Computing 2nd power */
    r__3 = 1.f - x[1];
    *f = r__1 * r__1 + r__3 * r__3;
    return 0;
} /* func_c */

int grad_c(float *x, float *g, float *ge, int *i0)
{
    /* System generated locals */
    float r__1;

    /* Parameter adjustments */
    --i0;
    --ge;
    --g;
    --x;

    /* Function Body */
/* Computing 2nd power */
    r__1 = x[1];
    g[1] = (x[2] - r__1 * r__1) * -4.f * x[1] - (1.f - x[1]) * 2.f;
/* Computing 2nd power */
    r__1 = x[1];
    g[2] = (x[2] - r__1 * r__1) * 2.f;
    g[1] *= i0[1];
    g[2] *= i0[2];
    return 0;
} /* grad_c */
